stack.sh does not set -e, so many error cases can go unhandled

Bug #1070986 reported by Robert Collins
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
devstack
Fix Released
Low
Unassigned

Bug Description

e.g. from the run where I noticed that this was the case:
+ timeout 60 sh -c 'while ! http_proxy= curl -s http://192.168.2.2:5000/v2.0/ >/dev/null; do sleep 1; done'
+ SERVICE_ENDPOINT=http://192.168.2.2:35357/v2.0
+ ADMIN_PASSWORD=nomoresecrete
+ SERVICE_TENANT_NAME=service
+ SERVICE_PASSWORD=nomoresecrete
+ SERVICE_TOKEN=cde90da2fb9471d421ed
+ SERVICE_ENDPOINT=http://192.168.2.2:35357/v2.0
+ SERVICE_HOST=192.168.2.2
+ S3_SERVICE_PORT=3333
+ KEYSTONE_CATALOG_BACKEND=sql
+ DEVSTACK_DIR=/home/stack/devstack
+ ENABLED_SERVICES=g-api,g-reg,key,n-api,n-crt,n-obj,n-cpu,n-net,cinder,c-sch,c-api,c-vol,n-sch,n-novnc,n-xvnc,n-cauth,horizon,mysql,rabbit
+ HEAT_API_CFN_PORT=
+ HEAT_API_PORT=
+ bash -x /home/stack/devstack/files/keystone_data.sh
+ ADMIN_PASSWORD=nomoresecrete
+ SERVICE_PASSWORD=nomoresecrete
+ export SERVICE_TOKEN=cde90da2fb9471d421ed
+ SERVICE_TOKEN=cde90da2fb9471d421ed
+ export SERVICE_ENDPOINT=http://192.168.2.2:35357/v2.0
+ SERVICE_ENDPOINT=http://192.168.2.2:35357/v2.0
+ SERVICE_TENANT_NAME=service
++ get_id keystone tenant-create --name=admin
+++ awk '/ id / { print $4 }'
+++ keystone tenant-create --name=admin
Unable to communicate with identity service: (403, 'Forbidden'). (HTTP 400)
++ echo
+ ADMIN_TENANT=
++ get_id keystone tenant-create --name=service
+++ awk '/ id / { print $4 }'
+++ keystone tenant-create --name=service
Unable to communicate with identity service: (403, 'Forbidden'). (HTTP 400)

And you can see that it carries on after the error blindly continuing. keystone exited non-zero, so stack.sh can/should have noticed.

Revision history for this message
Robert Collins (lifeless) wrote :

Another example today; nova-api-os-volume was removed, but not from setup.py, and setup.py then fails to install all the subsequent scripts, but devstack carries blithely on...

Revision history for this message
Robert Collins (lifeless) wrote :

(the lack of removal from setup.py was a temporary glitch in the baremetal branch, but it still lead to head-scratching :0

Dean Troyer (dtroyer)
Changed in devstack:
status: New → Triaged
importance: Undecided → Low
Revision history for this message
Dean Troyer (dtroyer) wrote :

This was finally finished in https://review.openstack.org/71996

Changed in devstack:
status: Triaged → Fix Released
To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.